Index: /GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.cpp
===================================================================
--- /GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.cpp	(revision 985)
+++ /GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.cpp	(revision 1019)
@@ -1,7 +1,5 @@
-//#include <GL\glut.h>
 #include <stdio.h>
 #include <string.h>
 #include <math.h>
-//#include <vl\VLf.h>
 
 #include "Foliage.h"
@@ -13,23 +11,29 @@
 // Parameters --> None
 //--------------------------------------------------------------------------------------------------------------------------------
-Foliage::Foliage(void):  MiArbol(NULL), Acth(NULL)
-{
-	 ppio= final = -1;
-}
-
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// Constructor with the name of a file cotaining the data
-//--------------------------------------------------------------------------------------------------------------------------------
-Foliage::Foliage ( Arbol *Arbol1)
-{
+Foliage::Foliage(const Geometry::SubMesh *leavesSubMesh, const char *simpSeq, Geometry::CREATEVERTEXDATAFUNC vdfun, Geometry::CREATEINDEXDATAFUNC idfun): 
+Acth(NULL),
+create_vertex_data_func(vdfun==NULL?Geometry::DefaultVertexDataCreator:vdfun),
+create_index_data_func(idfun==NULL?Geometry::DefaultIndexDataCreator:idfun),
+vertexdata(NULL), Leaves(NULL), MinDet(NULL)
+{
+	cx = cy= cz= 0;
+	ppio= final = -1;
+
+	ReadVertices(leavesSubMesh);
+	ReadLeafs(leavesSubMesh);
+	if (!ReadSimpSeq(simpSeq)) exit(1);
+	RellenoRaiz();
+	CalculaTexCoordsYNorms();
+
+
+	// esto no sé si devería haber akí
+	indexdata->SetNumValidIndices(0);
+
 	int h=0;
 
 
-	MiArbol = Arbol1;
-
-	Acth  = new Activas[(MiArbol->nHojas)*8];
-
-	for ( h=0; h < MiArbol->nHojas; h++) {
+	Acth  = new Activas[nHojas*8];
+
+	for ( h=0; h < nHojas; h++) {
 
 		Acth[h].indice = h;
@@ -43,4 +47,34 @@
 				
 	ppio = 0;
+	final = nHojas-1;
+	nhactivas = nHojas;
+
+}
+
+/*
+//--------------------------------------------------------------------------------------------------------------------------------
+// Constructor with the name of a file cotaining the data
+//--------------------------------------------------------------------------------------------------------------------------------
+Foliage::Foliage ( Arbol *Arbol1)
+{
+	int h=0;
+
+
+	MiArbol = Arbol1;
+
+	Acth  = new Activas[(MiArbol->nHojas)*8];
+
+	for ( h=0; h < MiArbol->nHojas; h++) {
+
+		Acth[h].indice = h;
+		if ( h != 0)
+		{
+			Acth[h].prev = (h-1);
+			Acth[h-1].next = h;
+		}
+
+	}
+				
+	ppio = 0;
 	final = (MiArbol->nHojas)-1;
 	nhactivas = MiArbol->nHojas;
@@ -48,5 +82,5 @@
 
 
-}
+}*/
 
 //--------------------------------------------------------------------------------------------------------------------------------
@@ -55,5 +89,8 @@
 Foliage::~Foliage (void)
 {
-	delete MiArbol;
+	if (vertexdata) delete vertexdata;
+	if (indexdata) delete indexdata;
+	delete[] Leaves;
+	delete MinDet;
 	delete Acth;
 }
@@ -71,18 +108,18 @@
 	glBegin (GL_TRIANGLE_STRIP);
 		glNormal3fv (aHoja.Normal);
-		MiArbol->Vertices[aHoja.Vert_Hoja[0]].GetCoordinates (a,b,c);
+		MiArbol->Vertices[aHoja.vertsLeaf[0]].GetCoordinates (a,b,c);
 		glTexCoord2f ( 0.0, 0.0);
 
 		glVertex3f (a,b,c);
 
-		MiArbol->Vertices[aHoja.Vert_Hoja[1]].GetCoordinates (a,b,c);
+		MiArbol->Vertices[aHoja.vertsLeaf[1]].GetCoordinates (a,b,c);
 		glTexCoord2f ( 0.0, 1.0);
 		glVertex3f (a,b,c);
 	
-		MiArbol->Vertices[aHoja.Vert_Hoja[2]].GetCoordinates (a,b,c);
+		MiArbol->Vertices[aHoja.vertsLeaf[2]].GetCoordinates (a,b,c);
 		glTexCoord2f ( 1.0, 0.0);
 		glVertex3f (a,b,c);
 
-		MiArbol->Vertices[aHoja.Vert_Hoja[3]].GetCoordinates (a,b,c);
+		MiArbol->Vertices[aHoja.vertsLeaf[3]].GetCoordinates (a,b,c);
 		glTexCoord2f ( 1.0, 1.0);
 		glVertex3f (a,b,c);
@@ -236,15 +273,15 @@
 
 	i = 0;
-	while ( MiArbol->MinDet[i].indice != -1)
-	{
-		j = MiArbol->MinDet[i].indice;
+	while ( MinDet[i].indice != -1)
+	{
+		j = MinDet[i].indice;
 		if (LeafinFrustum ( j, frustum) == true) {
-		//	printf("dentro %i y el padre es %i\n", j, MiArbol->Hojas[MiArbol->MinDet[i].indice].padre);
-			MiArbol->Hojas[j].visible = 1;
+		//	printf("dentro %i y el padre es %i\n", j, MiArbol->Hojas[MiArbol->MinDet[i].indice].parent);
+			Leaves[j].visible = 1;
 		}
 		else  
 		{
 		//	printf("fuera %i\n", j);
-			MiArbol->Hojas[j].visible = 0;
+			Leaves[j].visible = 0;
 		}
 
@@ -269,6 +306,6 @@
 	for (j =0; j<4; j++)
 	{
-//		MiArbol->Vertices[MiArbol->Hojas[i].Vert_Hoja[j]].GetCoordinates (a,b,c);
-		MiArbol->vertexdata->GetVertexCoord(MiArbol->Hojas[i].Vert_Hoja[j],a,b,c);
+//		MiArbol->Vertices[MiArbol->Hojas[i].vertsLeaf[j]].GetCoordinates (a,b,c);
+		vertexdata->GetVertexCoord(Leaves[i].vertsLeaf[j],a,b,c);
 		v[0]=a; v[1]=b;	v[2]=c; v[3]=1;
 
@@ -336,5 +373,5 @@
 
 
-bool Foliage::Criterio ( Hoja &aHoja,  char ch, float rva, float rvb,float rvc, float rvd, float radio)
+bool Foliage::Criterio ( Leaf &aLeaf,  char ch, float rva, float rvb,float rvc, float rvd, float radio)
 {
 	float a,b,c; // coordenadas del primero de los vertices en la hoja
@@ -346,13 +383,9 @@
 	float ccx, ccy, ccz;
 
-	
-
-//	MiArbol->Vertices[aHoja.Vert_Hoja[0]].GetCoordinates (a,b,c);
-	MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[0],a,b,c);
-
-	ccx = MiArbol->cx;
-	ccy = MiArbol->cy;
-	ccz = MiArbol->cz;
-
+	vertexdata->GetVertexCoord(aLeaf.vertsLeaf[0],a,b,c);
+
+	ccx = cx;
+	ccy = cy;
+	ccz = cz;
 
 	if ( (ch == 'p') || (ch == 'd'))
@@ -361,14 +394,14 @@
 	if (DondeEsta (a,b,c, rva,rvb,rvc,rvd) == 1)
 	{
-//		MiArbol->Vertices[aHoja.Vert_Hoja[1]].GetCoordinates (d,e,f);
-		MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[1],d,e,f);
+//		MiArbol->Vertices[aHoja.vertsLeaf[1]].GetCoordinates (d,e,f);
+		vertexdata->GetVertexCoord(aLeaf.vertsLeaf[1],d,e,f);
 		if (DondeEsta (d,e,f, rva,rvb,rvc,rvd) == 1)
 		{
-//			MiArbol->Vertices[aHoja.Vert_Hoja[2]].GetCoordinates (g,h,i);
-			MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[2],g,h,i);
+//			MiArbol->Vertices[aHoja.vertsLeaf[2]].GetCoordinates (g,h,i);
+			vertexdata->GetVertexCoord(aLeaf.vertsLeaf[2],g,h,i);
 			if (DondeEsta (g,h,i, rva,rvb,rvc,rvd) == 1)
 			{
-//				MiArbol->Vertices[aHoja.Vert_Hoja[3]].GetCoordinates (j,k,l);
-				MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[3],j,k,l);
+//				Vertices[aHoja.vertsLeaf[3]].GetCoordinates (j,k,l);
+				vertexdata->GetVertexCoord(aLeaf.vertsLeaf[3],j,k,l);
 				if (DondeEsta (j,k,l, rva,rvb,rvc,rvd) == 1) inter = true;
 			}
@@ -388,18 +421,18 @@
 
 	{
-//		MiArbol->Vertices[aHoja.Vert_Hoja[1]].GetCoordinates (a,b,c);
-		MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[1],a,b,c);
+//		MiArbol->Vertices[aHoja.vertsLeaf[1]].GetCoordinates (a,b,c);
+		vertexdata->GetVertexCoord(aLeaf.vertsLeaf[1],a,b,c);
 		dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));
 
 		if (dist >  radio)
 		{
-//			MiArbol->Vertices[aHoja.Vert_Hoja[2]].GetCoordinates (a,b,c);
-			MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[2],a,b,c);
+//			MiArbol->Vertices[aHoja.vertsLeaf[2]].GetCoordinates (a,b,c);
+			vertexdata->GetVertexCoord(aLeaf.vertsLeaf[2],a,b,c);
 			dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));
 
 			if (dist >  radio)
 			{
-//				MiArbol->Vertices[aHoja.Vert_Hoja[3]].GetCoordinates (a,b,c);
-				MiArbol->vertexdata->GetVertexCoord(aHoja.Vert_Hoja[3],a,b,c);
+//				MiArbol->Vertices[aHoja.vertsLeaf[3]].GetCoordinates (a,b,c);
+				vertexdata->GetVertexCoord(aLeaf.vertsLeaf[3],a,b,c);
 				dist =(float)sqrt ((a-ccx)*(a-ccx)+ (b-ccy)*(b-ccy)+ (c-ccz)*(c-ccz));
 
@@ -442,6 +475,6 @@
 	spli = -1;
 
-	renvol = MiArbol->rad;
-	centroz = MiArbol->cz;
+	renvol = rad;
+	centroz = cz;
 //	printf (" el centro en %f y el radio es de %f\n", centroz, renvol);
 
@@ -473,12 +506,12 @@
 		//COLAPSAR
 
-		if (( Criterio ( MiArbol->Hojas[i], ch, rva,rvb,rvc,rvd, radio )== false) && (MiArbol->Hojas[i].padre != -1)) 
+		if (( Criterio ( Leaves[i], ch, rva,rvb,rvc,rvd, radio )== false) && (Leaves[i].parent != -1)) 
 		{
 			// SI ESTA FUESE LA HOJA IZQUIERDA Y LA DERECHA NO CUMPLE TAMPOCO EL CRITERIO
-			if ((MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi == i) &&
-				( Criterio (MiArbol->Hojas[MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod] , ch, rva,rvb,rvc,rvd, radio )== false))
+			if ((Leaves[Leaves[i].parent].childLeft == i) &&
+				( Criterio (Leaves[Leaves[Leaves[i].parent].childRight] , ch, rva,rvb,rvc,rvd, radio )== false))
 			{	//hay que colapsar
-				if (EsActivo(MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod) == false)
-					lista = Forzar_Colapse (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod, hpost, ch, rva,rvb,rvc,rvd, radio); // para activarla
+				if (EsActivo(Leaves[Leaves[i].parent].childRight) == false)
+					lista = Forzar_Colapse (Leaves[Leaves[i].parent].childRight, hpost, ch, rva,rvb,rvc,rvd, radio); // para activarla
 				else lista = true;
 									
@@ -486,9 +519,9 @@
 			else
 			// SI ESTA FUESE LA HOJA DERECHA Y LA IZQUIERDA NO CUMPLE TAMPOCO EL CRITERIO
-			if ((MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod == i) &&
-				( Criterio (MiArbol->Hojas[MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi] , ch, rva,rvb,rvc,rvd, radio )== false))
+			if ((Leaves[Leaves[i].parent].childRight == i) &&
+				( Criterio (Leaves[Leaves[Leaves[i].parent].childLeft] , ch, rva,rvb,rvc,rvd, radio )== false))
 			{//hay que colapsar
-				if (EsActivo(MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi) == false)
-					 lista = Forzar_Colapse (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi, hpost,  ch, rva,rvb,rvc,rvd, radio); // para activarla
+				if (EsActivo(Leaves[Leaves[i].parent].childLeft) == false)
+					 lista = Forzar_Colapse (Leaves[Leaves[i].parent].childLeft, hpost,  ch, rva,rvb,rvc,rvd, radio); // para activarla
 				else  lista = true;
 					
@@ -501,5 +534,5 @@
 				lista = false;
 				
-					ColapsaHoja ( MiArbol->Hojas[i].padre, hpost);
+					ColapsaHoja ( Leaves[i].parent, hpost);
 			}
 					
@@ -535,10 +568,10 @@
 
 	//actualizo los punteros del ppio y del final, y post
-	while (( ppio == MiArbol->Hojas[h].hijoi) || ( ppio == MiArbol->Hojas[h].hijod))
+	while (( ppio == Leaves[h].childLeft) || ( ppio == Leaves[h].childRight))
 		ppio = Acth[ppio].next;
-	while (( final == MiArbol->Hojas[h].hijoi) || ( final == MiArbol->Hojas[h].hijod))
+	while (( final == Leaves[h].childLeft) || ( final == Leaves[h].childRight))
 		 final = Acth[final].prev; 
 
-	while (( post == MiArbol->Hojas[h].hijoi) || ( post == MiArbol->Hojas[h].hijod))
+	while (( post == Leaves[h].childLeft) || ( post == Leaves[h].childRight))
 		 post = Acth[post].next; 
 
@@ -547,20 +580,20 @@
 	//COLAPSAR = QUITO DOS DE ACTIVOS PONGO UNO A ACTIVO
 
-	if (Acth[MiArbol->Hojas[h].hijoi].next != -1)
-		Acth[Acth[MiArbol->Hojas[h].hijoi].next].prev = Acth[MiArbol->Hojas[h].hijoi].prev;
-	if (Acth[MiArbol->Hojas[h].hijoi].prev != -1)
-		Acth[Acth[MiArbol->Hojas[h].hijoi].prev].next = Acth[MiArbol->Hojas[h].hijoi].next;
-
-	if (Acth[MiArbol->Hojas[h].hijod].next != -1)
-		Acth[Acth[MiArbol->Hojas[h].hijod].next].prev = Acth[MiArbol->Hojas[h].hijod].prev;
-	if (Acth[MiArbol->Hojas[h].hijod].prev != -1)
-		Acth[Acth[MiArbol->Hojas[h].hijod].prev].next = Acth[MiArbol->Hojas[h].hijod].next;
+	if (Acth[Leaves[h].childLeft].next != -1)
+		Acth[Acth[Leaves[h].childLeft].next].prev = Acth[Leaves[h].childLeft].prev;
+	if (Acth[Leaves[h].childLeft].prev != -1)
+		Acth[Acth[Leaves[h].childLeft].prev].next = Acth[Leaves[h].childLeft].next;
+
+	if (Acth[Leaves[h].childRight].next != -1)
+		Acth[Acth[Leaves[h].childRight].next].prev = Acth[Leaves[h].childRight].prev;
+	if (Acth[Leaves[h].childRight].prev != -1)
+		Acth[Acth[Leaves[h].childRight].prev].next = Acth[Leaves[h].childRight].next;
 
 	
 	//  desconecto a los hijos
-	Acth[MiArbol->Hojas[h].hijoi].prev = -1;
-	Acth[MiArbol->Hojas[h].hijoi].next = -1;
-	Acth[MiArbol->Hojas[h].hijod].prev = -1;
-	Acth[MiArbol->Hojas[h].hijod].next = -1;
+	Acth[Leaves[h].childLeft].prev = -1;
+	Acth[Leaves[h].childLeft].next = -1;
+	Acth[Leaves[h].childRight].prev = -1;
+	Acth[Leaves[h].childRight].next = -1;
 
 	//añado al final
@@ -596,15 +629,15 @@
 		
 		h = listah.GetCola ();//coger la cola
-		if (MiArbol->Hojas[h].hijoi != -1) 
-
-		{ if (!EsActivo (MiArbol->Hojas[h].hijoi ))
-			listah.Inserta (MiArbol->Hojas[h].hijoi);
+		if (Leaves[h].childLeft != -1) 
+
+		{ if (!EsActivo (Leaves[h].childLeft ))
+			listah.Inserta (Leaves[h].childLeft);
 			
-		  if ( (!EsActivo (MiArbol->Hojas[h].hijod)) )	
-			listah.Inserta (MiArbol->Hojas[h].hijod);
-		
-		  if (EsActivo (MiArbol->Hojas[h].hijoi) && EsActivo (MiArbol->Hojas[h].hijod )) 
-			  if((Criterio ( MiArbol->Hojas[MiArbol->Hojas[h].hijoi] ,ch, rva,rvb,rvc,rvd, radio )== false) &&
-				  (Criterio ( MiArbol->Hojas[MiArbol->Hojas[h].hijod], ch, rva,rvb,rvc,rvd, radio ) == false))
+		  if ( (!EsActivo (Leaves[h].childRight)) )	
+			listah.Inserta (Leaves[h].childRight);
+		
+		  if (EsActivo (Leaves[h].childLeft) && EsActivo (Leaves[h].childRight )) 
+			  if((Criterio ( Leaves[Leaves[h].childLeft] ,ch, rva,rvb,rvc,rvd, radio )== false) &&
+				  (Criterio ( Leaves[Leaves[h].childRight], ch, rva,rvb,rvc,rvd, radio ) == false))
 			{
 		    	ColapsaHoja ( h, hpost);
@@ -642,7 +675,7 @@
 
 	// 1 enlazo los hijos 
-	Acth[MiArbol->Hojas[h].hijoi].next = MiArbol->Hojas[h].hijod;
-	Acth[MiArbol->Hojas[h].hijod].prev = MiArbol->Hojas[h].hijoi;
-	Acth[MiArbol->Hojas[h].hijod].next = -1;
+	Acth[Leaves[h].childLeft].next = Leaves[h].childRight;
+	Acth[Leaves[h].childRight].prev = Leaves[h].childLeft;
+	Acth[Leaves[h].childRight].next = -1;
 
 	//y desconecto al padre
@@ -655,7 +688,7 @@
 	
 	//añado al final los hijos 
-	Acth[MiArbol->Hojas[h].hijoi].prev = final;
-	Acth[final].next = MiArbol->Hojas[h].hijoi;
-	final = MiArbol->Hojas[h].hijod;
+	Acth[Leaves[h].childLeft].prev = final;
+	Acth[final].next = Leaves[h].childLeft;
+	final = Leaves[h].childRight;
 
 }
@@ -676,16 +709,16 @@
 	nodo = -1;
 
-	if (MiArbol->Hojas[h].hijoi != -1) 
+	if (Leaves[h].childLeft != -1) 
 
 	{  // si el hijo derecho o el izquierdo están en la zona de máximo detalle, haré que estos se activen 	
-		  if ( (Criterio (MiArbol->Hojas[MiArbol->Hojas[h].hijoi],  ch, rva,rvb,rvc,rvd, radio ) == true) ||
-			  (Criterio (MiArbol->Hojas[MiArbol->Hojas[h].hijod], ch, rva,rvb,rvc,rvd, radio ) == true))
+		  if ( (Criterio (Leaves[Leaves[h].childLeft],  ch, rva,rvb,rvc,rvd, radio ) == true) ||
+			  (Criterio (Leaves[Leaves[h].childRight], ch, rva,rvb,rvc,rvd, radio ) == true))
 			
-				nodo = MiArbol->Hojas[h].hijoi; 
+				nodo = Leaves[h].childLeft; 
 			
 			else // si no, bajo un nivel más hasta encontrar algún descendiente que se encuentre en la zona de + detalle
 			{
-				nodo = Chequea_Split (MiArbol->Hojas[h].hijoi,  ch, rva,rvb,rvc,rvd, radio);
-				if ( nodo == -1 ) nodo = Chequea_Split (MiArbol->Hojas[h].hijod, ch, rva,rvb,rvc,rvd, radio);
+				nodo = Chequea_Split (Leaves[h].childLeft,  ch, rva,rvb,rvc,rvd, radio);
+				if ( nodo == -1 ) nodo = Chequea_Split (Leaves[h].childRight, ch, rva,rvb,rvc,rvd, radio);
 			}
 				  
@@ -711,10 +744,10 @@
 
 	bien = false;
-	h = MiArbol->Hojas[hoja].padre;
+	h = Leaves[hoja].parent;
 	listah.Inserta (h); // Inserta un dato en la lista
 
 	while ( h != padre)
 	{
-		h = MiArbol->Hojas[h].padre;
+		h = Leaves[h].parent;
 		listah.Inserta (h); // Inserta un dato en la lista
 	}
@@ -750,5 +783,5 @@
 	{
 		difdist = dmax - dmin;
-		difhojas = MiArbol->nHojas - MiArbol->minHojas;
+		difhojas = nHojas - minHojas;
 
 		d = dist - dmin;
@@ -758,12 +791,12 @@
 		nhojas = int(abs(d*difhojas /difdist));
 
-		AjusteHojas ((MiArbol->nHojas)-nhojas);
+		AjusteHojas ((nHojas)-nhojas);
 
 	}
 	else if (dist > dmax) {
-		AjusteHojas (MiArbol->minHojas);
+		AjusteHojas (minHojas);
 	}
 	else if (dist < dmin) {
-		AjusteHojas (MiArbol->nHojas);
+		AjusteHojas (nHojas);
 	}
 		
@@ -775,5 +808,5 @@
 void Foliage::AjusteHojas( int nhojas)
 {
-	if ((nhojas <= MiArbol->nHojas) && (nhojas >= MiArbol->minHojas))
+	if ((nhojas <= nHojas) && (nhojas >= minHojas))
 	{
 		if ( nhojas < nhactivas) {
@@ -810,15 +843,15 @@
  		hpost = Acth[i].next;
 
-			if ( MiArbol->Hojas[i].padre != -1) 
-				if ( MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi == i)
-				{if ( EsActivo (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijod ) )
+			if ( MiArbol->Hojas[i].parent != -1) 
+				if ( MiArbol->Hojas[MiArbol->Hojas[i].parent].childLeft == i)
+				{if ( EsActivo (MiArbol->Hojas[MiArbol->Hojas[i].parent].childRight ) )
 				{ 
-					ColapsaHoja ( MiArbol->Hojas[i].padre, hpost);
+					ColapsaHoja ( MiArbol->Hojas[i].parent, hpost);
 					nhojas --; }
 				}
 				else 
-				{if ( EsActivo (MiArbol->Hojas[MiArbol->Hojas[i].padre].hijoi ) )
+				{if ( EsActivo (MiArbol->Hojas[MiArbol->Hojas[i].parent].childLeft ) )
 				{
-					ColapsaHoja ( MiArbol->Hojas[i].padre, hpost); 
+					ColapsaHoja ( MiArbol->Hojas[i].parent, hpost); 
 					nhojas --; }
 				}
@@ -838,10 +871,10 @@
 	j = num;
 	h = final+1;
-		while ((h<=MiArbol->TotHojas) && (j>0))
+		while ((h<=TotHojas) && (j>0))
 		{
-			while (( ppio == MiArbol->Hojas[h].hijoi) || ( ppio == MiArbol->Hojas[h].hijod))
+			while (( ppio == Leaves[h].childLeft) || ( ppio == Leaves[h].childRight))
 				ppio = Acth[ppio].next;
 
-			while (( final == MiArbol->Hojas[h].hijoi) || ( final == MiArbol->Hojas[h].hijod))
+			while (( final == Leaves[h].childLeft) || ( final == Leaves[h].childRight))
 				final = Acth[final].prev; 
 
@@ -849,20 +882,20 @@
 			//COLAPSAR = QUITO DOS DE ACTIVOS PONGO UNO A ACTIVO
 
-			if (Acth[MiArbol->Hojas[h].hijoi].next != -1)
-				Acth[Acth[MiArbol->Hojas[h].hijoi].next].prev = Acth[MiArbol->Hojas[h].hijoi].prev;
-			if (Acth[MiArbol->Hojas[h].hijoi].prev != -1)
-				Acth[Acth[MiArbol->Hojas[h].hijoi].prev].next = Acth[MiArbol->Hojas[h].hijoi].next;
-
-			if (Acth[MiArbol->Hojas[h].hijod].next != -1)
-				Acth[Acth[MiArbol->Hojas[h].hijod].next].prev = Acth[MiArbol->Hojas[h].hijod].prev;
-			if (Acth[MiArbol->Hojas[h].hijod].prev != -1)
-				Acth[Acth[MiArbol->Hojas[h].hijod].prev].next = Acth[MiArbol->Hojas[h].hijod].next;
+			if (Acth[Leaves[h].childLeft].next != -1)
+				Acth[Acth[Leaves[h].childLeft].next].prev = Acth[Leaves[h].childLeft].prev;
+			if (Acth[Leaves[h].childLeft].prev != -1)
+				Acth[Acth[Leaves[h].childLeft].prev].next = Acth[Leaves[h].childLeft].next;
+
+			if (Acth[Leaves[h].childRight].next != -1)
+				Acth[Acth[Leaves[h].childRight].next].prev = Acth[Leaves[h].childRight].prev;
+			if (Acth[Leaves[h].childRight].prev != -1)
+				Acth[Acth[Leaves[h].childRight].prev].next = Acth[Leaves[h].childRight].next;
 
 	
 			//  desconecto a los hijos
-			Acth[MiArbol->Hojas[h].hijoi].prev = -1;
-			Acth[MiArbol->Hojas[h].hijoi].next = -1;
-			Acth[MiArbol->Hojas[h].hijod].prev = -1;
-			Acth[MiArbol->Hojas[h].hijod].next = -1;
+			Acth[Leaves[h].childLeft].prev = -1;
+			Acth[Leaves[h].childLeft].next = -1;
+			Acth[Leaves[h].childRight].prev = -1;
+			Acth[Leaves[h].childRight].next = -1;
 
 			//añado al final
@@ -893,5 +926,5 @@
 		hpost = Acth[i].next;
 
-		if (MiArbol->Hojas[i].hijoi != -1){
+		if (MiArbol->Leaves[i].childLeft != -1){
 					SplitHoja(i, hpost);
 					nhojas --;
@@ -927,8 +960,8 @@
 	i = h++;
 	
-	while ((EsActivo (i) == false) || (i> MiArbol->TotHojas))
+	while ((EsActivo (i) == false) || (i> TotHojas))
 		i++;
 
-	if (i > MiArbol->TotHojas) i=-1;
+	if (i > TotHojas) i=-1;
 
 
@@ -943,30 +976,30 @@
 	j = num;
 	h = final;
-	while ((h > MiArbol->nHojas) &&  (j>0))
+	while ((h > nHojas) &&  (j>0))
 	{
 
 		///////////// insertar a los hijos en orden segun su indice
 		//hijo izquierdo
-		ant = AnteriorActivo (MiArbol->Hojas[h].hijoi);
-		post = PosteriorActivo (MiArbol->Hojas[h].hijoi);
-
-
-		Acth[MiArbol->Hojas[h].hijoi].next = post;
-		Acth[MiArbol->Hojas[h].hijoi].prev = ant;
-		if (ant != -1) Acth[ant].next = MiArbol->Hojas[h].hijoi;
-			else ppio = MiArbol->Hojas[h].hijoi;
-		if (post != -1) Acth[post].prev = MiArbol->Hojas[h].hijoi;
+		ant = AnteriorActivo (Leaves[h].childLeft);
+		post = PosteriorActivo (Leaves[h].childLeft);
+
+
+		Acth[Leaves[h].childLeft].next = post;
+		Acth[Leaves[h].childLeft].prev = ant;
+		if (ant != -1) Acth[ant].next = Leaves[h].childLeft;
+			else ppio = Leaves[h].childLeft;
+		if (post != -1) Acth[post].prev = Leaves[h].childLeft;
 
 		
 		//hijo derecho
-		ant = AnteriorActivo (MiArbol->Hojas[h].hijod);
-		post = PosteriorActivo (MiArbol->Hojas[h].hijod);
-
-
-		Acth[MiArbol->Hojas[h].hijod].next = post;
-		Acth[MiArbol->Hojas[h].hijod].prev = ant;
-		if (ant != -1)  Acth[ant].next = MiArbol->Hojas[h].hijod;
-				else ppio = MiArbol->Hojas[h].hijod;
-		if (post != -1) Acth[post].prev = MiArbol->Hojas[h].hijod;
+		ant = AnteriorActivo (Leaves[h].childRight);
+		post = PosteriorActivo (Leaves[h].childRight);
+
+
+		Acth[Leaves[h].childRight].next = post;
+		Acth[Leaves[h].childRight].prev = ant;
+		if (ant != -1)  Acth[ant].next = Leaves[h].childRight;
+				else ppio = Leaves[h].childRight;
+		if (post != -1) Acth[post].prev = Leaves[h].childRight;
 
 
@@ -992,2 +1025,287 @@
 
  }
+
+void Foliage::ReadVertices(const Geometry::SubMesh *submesh)
+{
+	int countv= int(submesh->mVertexBuffer->mVertexCount);
+	vertexdata = create_vertex_data_func(2*countv);
+	Leaves = new Leaf[countv*2];
+	indexdata = create_index_data_func(countv*2*3); // 3 indices x 2 triangulos x hoja
+	
+	vertexdata->Begin();
+	for (int i=0; i<countv; i++)
+	{
+		vertexdata->SetVertexCoord( i,	submesh->mVertexBuffer->mPosition[i].x, 
+										submesh->mVertexBuffer->mPosition[i].y, 
+										submesh->mVertexBuffer->mPosition[i].z );
+	}
+	vertexdata->End();
+
+	TotVerts = countv;
+}
+
+
+void Foliage::GetNormalH (Leaf &aleaf)
+{
+
+	float onex, oney, onez;
+	float twox, twoy, twoz;
+	float threex, threey, threez;
+
+/*	Vertices[aHoja.vertsLeaf[0]].GetCoordinates (onex, oney, onez);
+	Vertices[aHoja.vertsLeaf[1]].GetCoordinates(twox, twoy, twoz);
+	Vertices[aHoja.vertsLeaf[2]].GetCoordinates (threex, threey, threez);*/
+
+	vertexdata->GetVertexCoord(aleaf.vertsLeaf[0],onex,oney,onez);
+	vertexdata->GetVertexCoord(aleaf.vertsLeaf[1],twox,twoy,twoz);
+	vertexdata->GetVertexCoord(aleaf.vertsLeaf[2],threex,threey,threez);
+
+	float v1[3]={twox-onex,twoy-oney,twoz-onez};
+	float v2[3]={threex-onex,threey-oney,threez-onez};
+
+	Normalize(v1,v1);
+	Normalize(v2,v2);
+	
+//	aleaf.Normal[0] = (twoz-onez)*(threey-oney) - (twoy-oney)*(threez-onez);
+//	aleaf.Normal[1] = (twox-onex)*(threez-onez) - (threex-onex)*(twoz-onez);
+//	aleaf.Normal[2] = (threex-onex)*(twoy-oney) - (twox-onex)*(threey-oney);
+
+	CrossProduct(v1,v2,aleaf.normal);
+	
+}
+
+void Foliage::CrossProduct(const float *v1, const float *v2, float *res)
+{
+	res[0] = v1[1]*v2[2] - v1[2]*v2[1];
+	res[1] = v1[2]*v2[0] - v1[0]*v2[2];
+	res[2] = v1[0]*v2[1] - v1[1]*v2[0];
+}
+
+void Foliage::Normalize(const float *v, float *res)
+{
+	float module=sqrtf(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
+	res[0]=v[0]/module;
+	res[1]=v[1]/module;
+	res[2]=v[2]/module;
+}
+
+void Foliage::ReadLeafs(const Geometry::SubMesh *submesh)
+{
+	int numtris = int(submesh->mIndexCount / 3);
+	nHojas =  numtris / 2;
+	for (int h=0; h<nHojas; h++)
+	{
+		Leaves[h].vertsLeaf[0] = submesh->mIndex[h*6+0];
+		Leaves[h].vertsLeaf[1] = submesh->mIndex[h*6+1];
+		Leaves[h].vertsLeaf[2] = submesh->mIndex[h*6+2];
+		Leaves[h].vertsLeaf[3] = submesh->mIndex[h*6+5];
+		Leaves[h].visible = 0;
+
+		GetNormalH ( Leaves[h]);
+	}
+}
+
+/// returns the number of total leafs
+bool Foliage::ReadSimpSeq(const char *simpSeqFile)
+{
+	FILE* fp_simpli;
+	char linea[256];
+	int v0, v1, v2, v3, tn, tv1,tv2, e=0;
+
+	if ((fp_simpli = fopen (simpSeqFile, "r")) == NULL)
+	{
+		printf ("No he podido abrir el fichero %s\n", simpSeqFile);
+		return false;
+	}
+	else
+	{
+		tn = nHojas;
+		while (fgets (linea, 255, fp_simpli) != NULL)
+		{
+			if (linea[0]<'0' || linea[0]>'9')
+				continue;
+		
+			//N 446 Ver 10176 10178 10169 10171  Tv 156 154 E 2
+
+//			sscanf(linea, "%s %lu %s %lu %lu  %lu %lu %s %lu %lu %s %i", 
+//				&str, &tn, &str, &v0, &v1, &v2, &v3, &str, &tv1, &tv2, &str, &e );
+			long int triviej00=-1, triviej01=-1;
+			long int triviej10=-1, triviej11=-1;
+			sscanf(linea, "%lu %lu %lu %lu & %lu %lu %lu %lu", &triviej00,&triviej01,&triviej10,&triviej11, &v0,&v1,&v2,&v3);
+
+			Leaves[tn].vertsLeaf[0] = v0;
+			Leaves[tn].vertsLeaf[1] = v1;
+			Leaves[tn].vertsLeaf[2] = v2;
+			Leaves[tn].vertsLeaf[3] = v3;
+
+			Leaves[tn].visible = 0;
+
+			GetNormalH  (Leaves[tn]);
+
+			tv1 = triviej00/2;
+			tv2 = triviej10/2;
+
+			Leaves[tn].childLeft= tv1;
+			Leaves[tn].childRight= tv2;
+
+			Leaves[tv1].parent = tn;
+			Leaves[tv2].parent = tn;		
+
+			tn++;
+		}
+
+	}
+
+	fclose(fp_simpli);
+
+	TotHojas=tn;
+		
+	return true;
+}
+
+void Foliage::RellenoRaiz (void)
+{
+	int i,j, k, t, cont;
+	bool esta, fin;
+
+	i=0;
+	k=-1;
+	cont =-1;
+
+	MinDet  = new Activas[nHojas*2];
+	
+	while (i<TotHojas)
+	{
+		j=i;
+		while (Leaves[j].parent > -1) j= Leaves[j].parent;
+		Leaves[i].root = j;
+
+
+		// para la estructura MinDet
+		if ( k == -1){
+			k++;
+			MinDet[k].indice = j;
+			cont =k;
+		}
+		else
+		{
+			t = 0;
+			esta = false;
+			fin = false;
+
+			while (( fin == false) && (esta == false))
+			{	if ( MinDet[t].indice == j) esta = true;
+					else t++;
+				if (MinDet[t].indice == -1) fin = true;
+			}
+
+			if ( esta == false) //añado al final
+			{
+				cont++;
+				MinDet[cont].indice = j;
+			}
+		}
+
+	i++;
+	}	
+
+	minHojas = cont;
+
+}
+
+void Foliage::CalculaTexCoordsYNorms(void)
+{	
+	vertexdata->Begin();
+	for (int i=0; i<nHojas; i++)
+	{	
+		const float* lanormal = Leaves[i].normal;
+		vertexdata->SetVertexNormal(Leaves[i].vertsLeaf[0], lanormal[0], lanormal[1], lanormal[2]);
+		vertexdata->SetVertexTexCoord(Leaves[i].vertsLeaf[0], 0.0f, 1.0f);
+
+		vertexdata->SetVertexNormal(Leaves[i].vertsLeaf[1], lanormal[0], lanormal[1], lanormal[2]);
+		vertexdata->SetVertexTexCoord(Leaves[i].vertsLeaf[1], 0.0f, 0.0f);
+
+		vertexdata->SetVertexNormal(Leaves[i].vertsLeaf[2], lanormal[0], lanormal[1], lanormal[2]);
+		vertexdata->SetVertexTexCoord(Leaves[i].vertsLeaf[2], 1.0f, 1.0f);
+
+		vertexdata->SetVertexNormal(Leaves[i].vertsLeaf[3], lanormal[0], lanormal[1], lanormal[2]);
+		vertexdata->SetVertexTexCoord(Leaves[i].vertsLeaf[3], 1.0f, 0.0f);
+
+
+/*		MiArbol->Vertices[aHoja.vertsLeaf[1]].GetCoordinates (a,b,c);
+		glTexCoord2f ( 0.0, 1.0);
+		glVertex3f (a,b,c);
+	
+		MiArbol->Vertices[aHoja.vertsLeaf[2]].GetCoordinates (a,b,c);
+		glTexCoord2f ( 1.0, 0.0);
+		glVertex3f (a,b,c);
+
+		MiArbol->Vertices[aHoja.vertsLeaf[3]].GetCoordinates (a,b,c);
+		glTexCoord2f ( 1.0, 1.0);
+		glVertex3f (a,b,c);*/
+	}
+	vertexdata->End();
+}
+
+Foliage::Foliage(const Foliage *ar)
+{
+	nHojas=ar->nHojas;
+	MinDet  = new Activas[nHojas*2];
+//	for (unsigned int i=0; i<nHojas*2; i++)
+//		MinDet[i]=ar->MinDet[i];
+	memcpy(MinDet,ar->MinDet,sizeof(Activas)*nHojas*2);
+	TotHojas=ar->TotHojas;
+	cx=ar->cx;
+	cy=ar->cy;
+	cz=ar->cz;
+	rad=ar->rad;
+	minHojas=ar->minHojas;
+	TotVerts=ar->TotVerts;
+
+	create_vertex_data_func=ar->create_vertex_data_func;
+	create_index_data_func=ar->create_index_data_func;
+	vertexdata=create_vertex_data_func(ar->vertexdata->GetNumVertices());
+	vertexdata->Begin(); 
+	for (unsigned int i=0; i<vertexdata->GetNumVertices(); i++) 
+	{
+		float va,vb,vc;
+		ar->vertexdata->GetVertexCoord(i,va,vb,vc);
+		vertexdata->SetVertexCoord(i,va,vb,vc);
+		ar->vertexdata->GetVertexNormal(i,va,vb,vc);
+		vertexdata->SetVertexNormal(i,va,vb,vc);
+	}
+	vertexdata->End();
+	indexdata=create_index_data_func(ar->indexdata->GetNumMaxIndices());
+	indexdata->Begin(); 
+	for (unsigned int i=0; i<indexdata->GetNumMaxIndices(); i++) 
+		indexdata->SetIndex(i,ar->indexdata->GetIndex(i));
+	indexdata->End();
+
+	Leaves=new Leaf[vertexdata->GetNumVertices()];
+//	for (unsigned int i=0; i<vertexdata->GetNumVertices(); i++) 
+//		Leaves[i]=ar->Leaves[i];
+	memcpy(Leaves,ar->Leaves,sizeof(Leaf)*vertexdata->GetNumVertices());
+
+	// esto no sé si devería haber akí
+	indexdata->SetNumValidIndices(0);
+
+	int h=0;
+
+	Acth  = new Activas[nHojas*8];
+
+	for ( h=0; h < nHojas; h++) {
+
+		Acth[h].indice = h;
+		if ( h != 0)
+		{
+			Acth[h].prev = (h-1);
+			Acth[h-1].next = h;
+		}
+
+	}
+				
+	ppio = 0;
+	final = nHojas-1;
+	nhactivas = nHojas;
+
+}
Index: /GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.h
===================================================================
--- /GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.h	(revision 830)
+++ /GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.h	(revision 1019)
@@ -3,12 +3,10 @@
 
 
-#include "arbol.h"
 #include "Activas.h"
-//#include "material.h"
+#include "GeoSubMesh.h"
 #include "tlista.h"
-//#include <vl\VLf.h>
 #include "TMatrix.h"
-
-
+#include "VertexData.h"
+#include "Leaf.h"
 
 class Foliage
@@ -16,20 +14,13 @@
 	public :
 
-	Arbol	 *MiArbol;
-	Activas  *Acth; // primera hoja activa
-	int ppio, final;
-	int nhactivas;
-	TMatrix mat_aux;
+		Activas  *Acth; // primera hoja activa
+		int ppio, final;
+		int nhactivas;
+		TMatrix mat_aux;
 
-	public :
-		Foliage (void); // Void constructor
-		Foliage ( Arbol* Arbol1 ); // Constructor with the name of a file cotaining the data
+		Foliage (const Geometry::SubMesh *, const char *simpSeq, Geometry::CREATEVERTEXDATAFUNC vdfun=NULL, Geometry::CREATEINDEXDATAFUNC idfun=NULL);
+		Foliage (const Foliage *);
 		virtual ~Foliage (void); // Destructor
 		
-		// sacar por pantalla
-/*		void Dibuja_Hoja ( Hoja&);
-		int  DibujarHojas (float frustum[6][4], float zoom);
-		void DibujaEsfera (float);*/
-
 		//culling
 		void Culling (float frustum[6][4]);
@@ -39,5 +30,5 @@
 		bool EsActivo (  int num);
 		int  DondeEsta (  float x, float y, float z, float rva, float rvb,float rvc, float rvd);
-		bool Criterio ( Hoja &aHoja, char ch, float rva, float rvb,float rvc, float rvd, float radio);
+		bool Criterio ( Leaf &, char ch, float rva, float rvb,float rvc, float rvd, float radio);
 		int  ResolucionV ( char c, float rva, float rvb,float rvc, float rvd, float radio);
 		void ColapsaHoja (int, int&);
@@ -56,8 +47,34 @@
 		void RCsplit (  int nhojas);
 
-		//impostores
-//		void DibujaCaja (float alfa, float d);
-//		int  DibujaMediaCopa ( char c, float rva, float rvb,float rvc, float rvd, float radio);
+		Geometry::VertexData *vertexdata;
+		Geometry::IndexData *indexdata;
+
+		Leaf   *Leaves;
+		Activas  *MinDet; // primera hoja activa
+		int nHojas;
+		int TotHojas;
 		
+		float cx,cy,cz; //centro de la copa// para los impostores y resolucion variable
+		float rad; //radio de la esfera envolvente
+		int minHojas;
+		int TotVerts;
+
+	private:
+		Geometry::CREATEVERTEXDATAFUNC create_vertex_data_func;		
+		Geometry::CREATEINDEXDATAFUNC create_index_data_func;
+
+		void ReadLeafs(const Geometry::SubMesh *);
+		void ReadVertices(const Geometry::SubMesh *);
+		bool ReadSimpSeq(const char*); /// returns true when successful
+		void RellenoRaiz (void);
+
+		void GetNormalH (Leaf&);
+//		void GetNormalT(Tronco&);
+
+		void CrossProduct(const float *v1, const float *v2, float *res);
+		void Normalize(const float *v, float *res);
+//		void CalculaNormalesVertice(void);
+		void CalculaTexCoordsYNorms(void);
+
 };
 
